<template>
  <div class="ui container">
    <div class="ui middle aligned grid">
      <div class="five wide column">
        <div class="ui list">
          <div class="item">
            <div class="content">
              <strong>{{ salesman.name }}</strong>
            </div>
          </div>
          <div class="item">
            <div class="content">
              <small>Vendedor</small>
            </div>
          </div>
          <div class="item">
            <div class="content">
              <small>{{ salesman.email }}</small>
            </div>
          </div>
          <!-- <div class="item">
               <div class="content">
               <small>15-2460-3590</small>
               </div>
               </div> -->
        </div>
      </div>

      <div class="six wide column">
        <h2 class="ui center aligned icon header">
          <i class="circular users icon"></i>
          D&D Panificados
          <div class="sub header">
            <a href="http://www.dydpanificados.com.ar">www.dydpanificados.com.ar</a>
          </div>
        </h2>
      </div>

      <div class="five wide column right aligned">
        <div class="ui list">
          <div class="item">
            <div class="content">
              <strong>Darío Podestá</strong>
            </div>
          </div>
          <div class="item">
            <div class="content">
              <small>Coord. Ventas</small>
            </div>
          </div>
          <div class="item">
            <div class="content">
              <small>pedidosdydpanificados@gmail.com.ar</small>
            </div>
          </div>
          <div class="item">
            <div class="content">
              <small>15-2460-3590</small>
            </div>
          </div>
        </div>
      </div>
    </div>
    <form class="ui tiny form">
      <h4 class="ui dividing header">Datos del Cliente</h4>
      <div class="fields">
        <div class="three wide field">
          <label>Fecha Ent</label>
          <input type="text" :value="order.deliveryDate | formatDate" readonly />
        </div>
        <div class="eight wide field">
          <label>Razón Social</label>
          <input type="text" :value="client.name" readonly />
        </div>
        <div class="three wide field">
          <label>Teléfono</label>
          <input type="text" :value="defaultTelephone" readonly />
        </div>
        <div class="two wide field">
          <label>Cód. Cte.</label>
          <input type="text" :value="client.code" readonly />
        </div>
      </div>
      <div class="fields">
        <div class="eight wide field">
          <label>Domicilio</label>
          <input type="text" :value="client.addressLine" readonly />
        </div>
        <div class="four wide field">
          <label>Localidad</label>
          <input type="text" :value="client.city" readonly />
        </div>
        <div class="four wide field">
          <label>CUIT</label>
          <input type="text" :value="client.cuit || 'No disponible'" readonly />
        </div>
      </div>
      <div class="inline fields">

      </div>
    </form>
    <h4 class="ui dividing header">Productos</h4>
    <table class="ui grey compact small striped table">
      <thead>
        <tr>
          <th>Marca</th>
          <th>Producto</th>
          <th>Cantidad</th>
          <th>P. Unit</th>
          <th>Importe</th>
          <th>Desc. ({{order.discount}}%)</th>
          <th>Imp. Final</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="item in items" :key="item._id" :class="{negative: item.isReturn}">
          <td>{{ item.product.brand }}</td>
          <td>{{ item.product.name }}</td>
          <td>{{ item.quantity }}</td>
          <td>{{ item.product.price | formatCurrency }}</td>
          <td>{{ item.total | formatCurrency }}</td>
          <td>{{ item.discount | formatCurrency }}</td>
          <td>{{ item.finalPrice | formatCurrency }}</td>
        </tr>
      </tbody>
      <tfoot >
        <tr>
          <th colspan="2"><strong>Totales</strong></th>
          <th>{{ totalQuantity }}</th>
          <th>-</th>
          <th>{{ totalPrice | formatCurrency }}</th>
          <th>{{ totalDiscount | formatCurrency }}</th>
          <th>{{ finalPrice | formatCurrency }}</th>
        </tr>
      </tfoot>
    </table>
  </div>
</template>

<script>
  import api from '@/feathers'

  export default {
    name: 'print-order',
    props: {
      id: {required: true, type: String}
    },
    data() {
      return {
        order: {},
        client: {},
        salesman: {},
        items: []
      }
    },
    computed: {
      totalQuantity() {
        return this
          .items
          .filter(item => item.isReturn === false)
          .reduce((accum, current) => accum + current.quantity, 0)
      },
      defaultTelephone() {
        return this.client.tel1 || this.client.tel2 || 'No disponible'
      },
      totalPrice() {
        return this
          .items.reduce((accum, current) => accum + current.total, 0)
      },
      totalDiscount() {
        return this
          .items.reduce((accum, current) => accum + current.discount, 0)
      },
      finalPrice() {
        return this
          .items.reduce((accum, current) => accum + current.finalPrice, 0)
      }
    },
    async created() {
      this.service = api.service('orders')
      this.order = await this.service.get(this.id, {query: {$populate: ['salesman', 'client', 'items.product']}})
      this.salesman = this.order.salesman
      this.client = this.order.client
      this.items = this.order.items.slice().sort((item1, item2) => {
        return item1.isReturn ? 1 : -1
      })
      this.items = this
        .items
        .map(item => {
          if (item.isReturn) {
            item.product.price = -item.product.price
            item.product.name = `Bonif. ${item.product.name}`
          }
          item.total = item.product.price * item.quantity
          item.discount = item.total * this.order.discount
          item.finalPrice = item.total - item.discount
          return item
        })
    }
  }
</script>

<style lang="sass">
  /* @import 'semantic-ui-css/semantic.css'; */
</style>
